// import classes
import { Component, Output, EventEmitter } from '@angular/core';

// mark this class as angular component using @Component decorator
@Component({
    selector: 'app-categories',
    templateUrl: './categories.component.html',
    styleUrls: ['./categories.component.css']
})

// component for categories
export class CategoriesComponent {

    // tell AppComponent it needs to change the title
    @Output() change_title_event = new EventEmitter();

    // properties for child components
    category_id;

    // properties used to identify what views to show
    show_read_categories_html=true;
    show_create_category_html=false;
    show_read_one_category_html=false;
    show_update_category_html=false;
    show_delete_category_html=false;

    // show details of a category
    showReadOneCategory($event){

        // set title and category ID
        this.changeTitle($event.title);
        this.category_id=$event.category_id;

        // hide all html then show only one html
        this.hideAll_Html();
        this.show_read_one_category_html=true;
    }

    // show the 'create category form'
    showCreateCategory($event){

        // set title
        this.changeTitle($event.title);

        // hide all html then show only one html
        this.hideAll_Html();
        this.show_create_category_html=true;
    }

    // show categories list
    showReadCategories($event){
        // set title
        this.changeTitle($event.title);

        // hide all html then show only one html
        this.hideAll_Html();
        this.show_read_categories_html=true;
    }

    // show the 'update category form'
    showUpdateCategory($event){

        // set title and category ID
        this.changeTitle($event.title);
        this.category_id=$event.category_id;

        // hide all html then show only one html
        this.hideAll_Html();
        this.show_update_category_html=true;
    }

    // show 'are you sure?' prompt to confirm deletion of a record
    showDeleteCategory($event){

        // set title and category ID
        this.changeTitle($event.title);
        this.category_id=$event.category_id;

        // hide all html then show only one html
        this.hideAll_Html();
        this.show_delete_category_html=true;
    }

    // hide all html views
    hideAll_Html(){
        this.show_read_categories_html=false;
        this.show_read_one_category_html=false;
        this.show_create_category_html=false;
        this.show_update_category_html=false;
        this.show_delete_category_html=false;
    }

    // change title in app component
    changeTitle(new_title){
        this.change_title_event.emit({ title: new_title });
    }

}
